<?php

    namespace IdnoPlugins\Withknown {

        class Main extends \Idno\Common\Plugin {

            function registerPages() {
                \Idno\Core\Idno::site()->template()->extendTemplate('account/menu/items','withknown/account/menu', true);
                \Idno\Core\Idno::site()->hijackPageHandler('begin/connect/?', '\IdnoPlugins\Withknown\Pages\Connect');
                \Idno\Core\Idno::site()->addPageHandler('withknown/settings/?', '\IdnoPlugins\Withknown\Pages\Settings');
                \Idno\Core\Idno::site()->addPageHandler('account/settings/services/?', '\IdnoPlugins\Withknown\Pages\Services');
                \Idno\Core\Idno::site()->addPageHandler('withknown/syndication/?', '\IdnoPlugins\Withknown\Pages\Syndication');
                \Idno\Core\Idno::site()->config->force_onboarding_connect = true;
            }

            function registerEventHooks() {
                \Idno\Core\Idno::site()->addEventHook('syndicate', function (\Idno\Core\Event $event) {

                    $object = $event->data()['object'];
                    $object_type = $event->data()['object_type'];
                    $syndication = \Idno\Core\Idno::site()->currentPage()->getInput('syndication');

                    $object_array = $object->saveToArray();
                    $object_array['url'] = $object->getURL();

                    if (\Idno\Core\Idno::site()->hub()) {
                        $results = \Idno\Core\Idno::site()->hub()->makeCall('hub/user/syndication/post',[

                            'object' => $object_array,
                            'object_type' => $object_type,
                            'syndication' => $syndication

                        ]);

                        if ($object_array = json_decode($results['content'],true)) {
                            $object->loadFromArray($object_array);
                            $object->save();
                        }
                    }

                });
            }

        }

    }